let h = 3;;
let z = [|[|5;2;3|];[|2;2;4|]|];;

(* Q21 *)

let num_of_coords p q l k = 
 if (p<=0) or (q<=0) or (l<0) or (l>=p) or (k<0) or (k>=q) 
  then raise (Invalid_argument "num_of_coords") else q * l + k;;

(* Q22 *)

let coords_of_num p q i = 
 if (p<=0) or (q<=0) or (i<0) or (i>=p*q) 
  then raise (Invalid_argument "coords_of_num") else (i / q,i mod q);;

(* Q24 *)

let voisins p q i = 
 if (p<=0) or (q<=0) or (i<0) or (i>=p*q) 
  then raise (Invalid_argument "voisins") else 
 let (l,k) = coords_of_num p q i in 
  let v_ouest = if k=0   then [] else [i-1] 
  and v_est   = if k=q-1 then [] else [i+1] 
  and v_nord  = if l=0   then [] else [i-q] 
  and v_sud   = if l=p-1 then [] else [i+q] 
 in v_ouest @ v_est @ v_nord @ v_sud;;

(* Q25 *)

let dimensions z = (vect_length z,vect_length z.(0));;

let varie_site p q j z d = 
  let (l,k) = coords_of_num p q j in z.(l).(k) <- z.(l).(k) + d;;

let tau i z = 
 let (p,q) = dimensions z in 
  if (i<0) or (i>=p*q) 
  then raise (Invalid_argument "tau") 
  else varie_site p q i z (-h-1); 
   do_list (fun j -> varie_site p q j z 1) (voisins p q i);;

(* Q26 *)

let intervalle d f = 
 let rec aux i j accu = if i > j then accu else aux i (j-1) (j::accu) 
  in aux d f [];;

let rec filter p = function 
 | [] -> [] 
 | t::q when p t -> t::(filter p q) 
 | _::q -> filter p q;;

let lsc h z = let (p,q) = dimensions z in 
 filter (fun i -> let (l,k) = coords_of_num p q i in z.(l).(k)>h) 
  (intervalle 0 (p*q-1));;

(* Q27 *)

let mu z = do_list (fun i -> tau i z) (lsc h z);;

(* Q28 *)

let rec relaxe z = match lsc h z with 
  | [] -> () 
  | _ -> mu z; relaxe z;;

(* Q40 *)

let tat_identit p q = let hh = 2 * h in 
 let m = make_matrix p q hh in 
  relaxe m; 
  for i = 0 to p-1 do 
   for j = 0 to q-1 do 
    m.(i).(j) <- 2 * h - m .(i).(j) 
   done
 done; relaxe m; m;;

(* visualisation *)

#open "graphics";;

open_graph "";;
let f = 1 and dx = 20 and dy = 20;;

let colorie  = function 
 | 0 -> white
 | 1 -> yellow
 | 2 -> green
 | 3 -> blue
 | 4 -> red
 | _ -> black;;

let colorie  = function 
 | 3 -> white
 | _ -> black;;

let pixel i j c = 
 set_color c;
 fill_rect (dx+f*i) (dy+f*j) f f;;

let dessine m = 
 clear_graph();
 for i = 0 to vect_length m - 1 do 
  for j = 0 to vect_length m.(0) - 1 do
    pixel i j (colorie m.(i).(j))
  done
 done;;

(* une autre solution de Q24 *)

(*
let voisins p q i = let (l,k) = coords_of_num p q i in 
 map (fun (Some x) -> x) (filter (fun x -> x<>None) 
 (map (fun (l,k) -> try Some(num_of_coords p q l k) 
  with _ -> None) [(l-1,k);(l+1,k);(l,k-1);(l,k+1)]));;

*)
